datacache <- new.env(hash=TRUE, parent=emptyenv())

hgu95dhsrefseq <- function() showQCData("hgu95dhsrefseq", datacache)
hgu95dhsrefseq_dbconn <- function() dbconn(datacache)
hgu95dhsrefseq_dbfile <- function() dbfile(datacache)
hgu95dhsrefseq_dbschema <- function(file="", show.indices=FALSE) dbschema(datacache, file=file, show.indices=show.indices)
hgu95dhsrefseq_dbInfo <- function() dbInfo(datacache)

hgu95dhsrefseqORGANISM <- "Homo sapiens"

.onLoad <- function(libname, pkgname)
{
    ## Connect to the SQLite DB
    dbfile <- system.file("extdata", "hgu95dhsrefseq.sqlite", package=pkgname, lib.loc=libname)
    assign("dbfile", dbfile, envir=datacache)
    dbconn <- dbFileConnect(dbfile)
    assign("dbconn", dbconn, envir=datacache)

    ## Create the OrgDb object
    sPkgname <- sub(".db$","",pkgname)
    txdb <- loadDb(system.file("extdata", paste(sPkgname,
      ".sqlite",sep=""), package=pkgname, lib.loc=libname),
                   packageName=pkgname)    
    dbNewname <- AnnotationDbi:::dbObjectName(pkgname,"ChipDb")
    ns <- asNamespace(pkgname)
    assign(dbNewname, txdb, envir=ns)
    namespaceExport(ns, dbNewname)
        
    ## Create the AnnObj instances
    ann_objs <- createAnnObjs.SchemaChoice("HUMANCHIP_DB", "hgu95dhsrefseq", "chip hgu95dhsrefseq", dbconn, datacache)
    mergeToNamespaceAndExport(ann_objs, pkgname)
    packageStartupMessage(AnnotationDbi:::annoStartupMessages("hgu95dhsrefseq.db"))
}

.onUnload <- function(libpath)
{
    dbFileDisconnect(hgu95dhsrefseq_dbconn())
}

